//
// Created by lukas on 06.03.21.
//

#include "LoadAnimator.h"
#include "Types.h"

void LoadAnimator::startLoadAnimation(Adafruit_NeoPixel* strip) {
  this->strip = strip;

  if (!timer.active())
    timer.attach_ms(100, std::bind(&LoadAnimator::animationStep, this));
}

void LoadAnimator::stopLoadAnimation() {
  timer.detach();
}

LoadAnimator::LoadAnimator() : timer(), x(0), y(0), nro(0), nroo(0), nrooo(0){};

void LoadAnimator::animationStep() {
  if (y == 0 && x < 7) {
    x++;
  } else if (x == 7 && y < 4) {
    y++;
  } else if (y == 4 && x > 0) {
    x--;
  } else if (x == 0 && y > 0) {
    y--;
  }

  uint8_t nr = types::convert(x + 2, y + 2);
  strip->clear();
  strip->setPixelColor(nr, Adafruit_NeoPixel::Color(0, 0, 150));
  if (nro != 0)
    strip->setPixelColor(nro, Adafruit_NeoPixel::Color(0, 0, 100));
  if (nroo != 0)
    strip->setPixelColor(nroo, Adafruit_NeoPixel::Color(0, 0, 50));
  if (nrooo != 0)
    strip->setPixelColor(nroo, Adafruit_NeoPixel::Color(0, 0, 25));
  strip->show();

  nrooo = nroo;
  nroo = nro;
  nro = nr;
}